const BackActionHandler = {
    init(){
        //console.log('BackActionHandler init')
        document.addEventListener(
            "keydown",
            function(event) {
                //console.log('keydown event', event);

                const code = event.keyCode || event.charCode;
                //console.log('key code =', code);
                if (code === undefined) return;

                switch(code){
                    case 27: //pc.KEY_ESCAPE:
                    //case 8: //pc.KEY_BACKSPACE:
                    case 461:
                    case 10009:{
                        BackActionHandler.backAction();
                        event.preventDefault();
                        event.stopPropagation();
                        break;
                    }
                }
            },
        );
    },

    backAction() {
        //console.log('back action');
        if(typeof Main !== 'undefined' && Main.instance)
        {
            try{
                if(SceneManager.currentScene !== SceneManager.menuScene) {
                    SceneManager.instance.loadScene(SceneManager.menuScene);
                } else {
                    Main.instance.quitPanel.enabled = !Main.instance.quitPanel.enabled;
                }
            }
            catch(error){
                console.error('Error when backAction, fallback to quit()\n', error);
                this.quit();
            }
        }
        else {
            this.quit();
        }
    },

    quit(){
        console.log('try quit');
        Megogo.sendMessage({method: 'landing:back', data: null});
        Megogo.sendMessage({method: 'landing:close', data: null});
    },
};

BackActionHandler.init();